export default class RestError {
	#code: ErrorCode;
	#message: string | undefined;

	constructor(code: ErrorCode, message: string | undefined = undefined) {
		this.#code = code;
		this.#message = message;
	}

	is(code: ErrorCode) {
		return this.#code === code;
	}

	toString() {
		return this.#message
			? `RestError(${this.#code}): ${this.#message}`
			: `RestError(${this.#code})`;
	}
}

export enum ErrorCode {
	INTERNAL_SERVER_ERROR = "INTERNAL_SERVER_ERROR",

	// Client-specific errors
	RESPONSE_NOT_JSON = "ResponseNotJson",
}
