import type * as events from "./events";

export type Dispatch =
	| { t: "MESSAGE_CREATE"; d: events.MessageCreate }
	| { t: "READY"; d: events.Ready };

export type ServerPayload =
	| { t: "D"; d: { e: Dispatch; s: string } }
	| { t: "ERROR"; d: { message: string } }
	| {
			t: "HELLO";
			d: {
				heartbeat_interval: number;
				guilds: string[];
				instances: { id: string; domain: string }[];
			};
	  }
	| { t: "HEARTBEAT_ACK"; d: { t: number } };

export type ClientPayload =
	| { t: "IDENTIFY"; d: { token: string } }
	| { t: "HEARTBEAT"; d: { t: number } };

export type Payload = ServerPayload | ClientPayload;
